﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ZylSoft.Gps;

namespace WebDemo
{
    public partial class _Default : System.Web.UI.Page
    {
        private NmeaDecoder gpsReceiver = new NmeaDecoder();

        protected void Page_Load(object sender, EventArgs e)
        {
           gpsReceiver.AltitudeChanged += GpsReceiverOnAltitudeChanged;
           gpsReceiver.SpeedChanged += GpsReceiverOnSpeedChanged;
           gpsReceiver.CourseChanged += GpsReceiverOnCourseChanged;

        }

        private void GpsReceiverOnCourseChanged(object sender, ParamEventArgs paramEventArgs)
        {
            LabelCourse.Text = "Course: " + paramEventArgs.Value.ToString() + "º";
        }

        private void GpsReceiverOnSpeedChanged(object sender, ParamEventArgs paramEventArgs)
        {
            LabelSpeed.Text = "Speed: " + paramEventArgs.Value.ToString() + " km/h";
        }

        private void GpsReceiverOnAltitudeChanged(object sender, ParamEventArgs paramEventArgs)
        {
            LabelAltitude.Text = "Altitude: " + paramEventArgs.Value.ToString() + " m";
        }

        protected void ButtonDecode_Click(object sender, EventArgs e)
        {
            gpsReceiver.Decode(TextBoxInput.Text);
            string latitude = "Latitude: " + gpsReceiver.Position.LatitudeDegree.ToString() + "º " + gpsReceiver.Position.LatitudeMinute.ToString() + "' " +
                              gpsReceiver.Position.LatitudeSecond + "'' " + gpsReceiver.Position.LatitudeDirection;
            string longitude = "Longitude: " + gpsReceiver.Position.LongitudeDegree.ToString() + "º " + gpsReceiver.Position.LongitudeMinute.ToString() + "' " +
                    gpsReceiver.Position.LongitudeSecond + "'' " + gpsReceiver.Position.LongitudeDirection;
            LabelLatitude.Text = latitude;
            LabelLongitude.Text = longitude;
            Bitmap satellitesBitmap = gpsReceiver.DrawSatellitesToBitmap(200, Color.Black, Color.White);
            MemoryStream ms = new MemoryStream();
            satellitesBitmap.Save(ms, ImageFormat.Gif);
            var base64Data = Convert.ToBase64String(ms.ToArray());
            imgCtrl.Src = "data:image/gif;base64," + base64Data;    
            satellitesBitmap.Dispose();
            ms.Close();
        }
    }
}